"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResendVerifySignupService = void 0;
const options_1 = require("../options");
const resend_verify_signup_1 = __importDefault(require("../methods/resend-verify-signup"));
const AuthenticationManagementBase_1 = require("./AuthenticationManagementBase");
class ResendVerifySignupService extends AuthenticationManagementBase_1.AuthenticationManagementBase {
    constructor(app, options) {
        super(app);
        const defaultOptions = (0, options_1.makeDefaultOptions)([
            'service',
            'notifier',
            'longTokenLen',
            'shortTokenLen',
            'shortTokenDigits',
            'delay',
            'identifyUserProps',
            'sanitizeUserForClient',
            'passParams'
        ]);
        this.options = Object.assign(defaultOptions, options);
    }
    _create(data, params) {
        return __awaiter(this, void 0, void 0, function* () {
            const passedParams = this.options.passParams && (yield this.options.passParams(params));
            return yield (0, resend_verify_signup_1.default)(this.optionsWithApp, data.user, data.notifierOptions, passedParams);
        });
    }
}
exports.ResendVerifySignupService = ResendVerifySignupService;
